# Contribute to Televerse 🚀

First off, thanks for taking the time to contribute! 🎉 As you already know, Televerse is a powerful Telegram Bot API wrapper solely for Flutter & Dart.

### Contents
- [What can I contribute? 🤔](#what-can-i-contribute)
- [How can I contribute? 👀](#how-can-i-contribute)
  - [1. Fork this repository. 🍴](#1-fork-this-repository)
  - [2. Create an issue on the main repository. 💬](#2-create-an-issue-on-the-main-repository)
  - [3. Start coding 🎉](#3-start-coding)
  - [4. Test your code 🧪](#4-test-your-code)
  - [5. Formatting & Style Guide](#5-formatting-and-style-guide)
  - [6. Create a pull request. 📤](#6-create-a-pull-request)
  - [That's it! 🎉](#thats-it)
- [What if I have a question? ❓](#what-if-i-have-a-question)
- [What if I have a suggestion? 🤔](#what-if-i-have-a-suggestion)

## What can I contribute?
You can contribute to Televerse in many ways. You can contribute to the code, documentation, examples, etc. You can also contribute by reporting bugs, suggesting new features, etc.

## How can I contribute?
Let's get started.

### 1. Fork this repository.

Make sure to fork all the branches not just the main branch. This is because we have the `dev` branch which is the main branch for development. All the changes are made to the `dev` branch and then merged to the `main` branch.

Most probably there'll be unmerged changes in the `dev` branch. So, to get the latest changes, make sure to fork all the branches.

### 2. Create an issue on the main repository.

An issue is a great way to start a discussion about the feature you want to add or the bug you want to fix. It is also a great way to get feedback from the maintainers and the community. Let's chat and may be get ourselves into a great idea.

### 3. Start coding

Once you've decided what you want to work on, it's time to start coding. You know this very well. So, I'll leave it to you.

### 4. Test your code

Once you're done with the code, it's time to test it. Make sure to test your code thoroughly. We don't want any bugs in the code. Do we? 😉

### 5. Formatting and Style Guide

We follow the [Effective Dart](https://dart.dev/effective-dart) style guide. Make sure to follow the [Effective Dart: Style](https://dart.dev/effective-dart/style) guide.

### 6. Create a pull request.

Once you're done with the code and testing, it's time to create a pull request. Make sure to create a pull request to the `dev` branch. We'll review your code and merge it to the `dev` branch. Once we have enough changes in the `dev` branch, we'll merge it to the `main` branch.

### That's it!

That's it! We'll take care of the rest. You can go and grab a cup of coffee ☕. We'll review your code and merge it to the `dev` branch. We'll possibly keep the conversation going on the pull request. So, make sure to check the pull request for any updates.

## What if I have a question?

If you have a question, you can create a [discussion](https://github.com/HeySreelal/televerse/discussions) on the main repository. We'll try to answer your question as soon as possible.

You can also join our [Telegram Group](https://t.me/televersedart) and ask your question there. We'll be more than happy to help you.

## What if I have a suggestion?

Just like questions, you can create a [discussion](https://github.com/HeySreelal/televerse/discussions) on the main repository or join our [Telegram Group](https://t.me/televersedart) and suggest your idea. We'll try to implement your idea as soon as possible.

# Thanks again for your interest in contributing to Televerse. ❤️